VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cINI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Reprsente un fichier Mox structur comme un fichier Ini. L'avantage de cette classe compar au
' classiques *PrivateProfileString API est que le contenu du fichier INI est conserv en mmoire et
' par consquent permet un accs plus rapide. C'est aussi une solution idale pour voir si des modifictaions ont t apportes
' dans le fichier et demander si une sauvegarde doit tre effectue

Private m_strFile As String
Private m_strLines() As String
Private m_fIsNew As Boolean

Private Sub Class_Initialize()
    ReDim m_strLines(10)
End Sub

' Set the current file name
Public Property Let File(ByVal strFile As String)
Dim i As Long
Dim lLine As Long
Dim strLines() As String
Dim lhFile As Long
Dim tOpenBuff As OFSTRUCT
Dim lSize As Long
Dim lBytesRead As Long
Dim ab() As Byte

    ' Read the file content
    Err.Clear
    On Error GoTo ErrorFlag
    
    ReDim strLines(10) As String

    'Open the file
    If IsWin9x Then
        lhFile = OpenFile(strFile, tOpenBuff, OF_READ)
    Else
        lhFile = CreateFile(strFile, GENERIC_READ, 0, ByVal 0&, OPEN_EXISTING, 0, 0)
    End If
    
    If lhFile <> 0 Then
        lSize = GetFileSize(lhFile, 0)
        
        If lSize > 0 Then
            ReDim ab(lSize) As Byte
            If ReadFile(lhFile, ab(0), lSize, lBytesRead, ByVal 0&) <> 0 Then
                For i = 0 To lBytesRead - 1
                    Select Case ab(i)
                    Case 10, 13
                        ' Ligne suivante
                        lLine = lLine + 1
                        If ab(i + 1) = 10 Or ab(i + 1) = 13 Then
                            i = i + 1
                        End If
                        
                        ' Evite trop de Redim Preserve car peu performant
                        If lLine > UBound(strLines) Then
                            ReDim Preserve strLines(UBound(strLines) * 2)
                        End If
                    
                    Case Else
                        strLines(lLine) = strLines(lLine) + Chr(ab(i))
                    
                    End Select
                Next
            Else
                Call Err.Raise(10001, , "Fail to read file " + strFile)
            End If
        End If
    Else
        Call Err.Raise(10002, , "Fail to open file " + strFile)
    End If
    
ErrorFlag:

    If lhFile <> 0 Then
        ' Close file handle:
        Call CloseHandle(lhFile)
    End If

    If Err.Number <> 0 Then
        Call MsgBox(Err.Description, vbOKOnly Or vbCritical, App.Title)
    Else
        m_strFile = strFile
        m_strLines = strLines
    End If
End Property

' Return the current file name
Public Property Get File() As String
    File = m_strFile
End Property

' Get if this class is the template of a new file
Public Property Get IsNew() As Boolean
    IsNew = m_fIsNew
End Property

' Set if this class is the template of a new file
' Not used in internal, just for consumer info
Public Property Let IsNew(ByVal fState As Boolean)
    m_fIsNew = fState
End Property

' Lit un string dans une section spcifie avec la cl donne
Public Function ReadString(ByVal strSection As String, ByVal strKey As String) As String
Dim strLine As String
Dim i As Long
Dim fInSection As Boolean
Dim lChar As Long

    ' Search section
    For i = 0 To UBound(m_strLines)
        ' Current Line
        strLine = m_strLines(i)
        If Len(strLine) > 0 Then
            If Left$(strLine, 1) <> ";" Then
                ' Compatibility with previous version
                If InStr(strLine, "'") = 1 Then
                    strLine = Right$(strLine, Len(strLine) - 1)
                End If
                
                If Left(strLine, 1) = "[" Then
                    If fInSection Then
                        ' Not found
                        Exit Function
                    ElseIf LCase(strLine) = LCase("[" + strSection + "]") Then
                        ' Matched section
                        fInSection = True
                    End If
                ElseIf fInSection Then
                    If LCase(Left(strLine, Len(strKey))) = LCase(strKey) Then
                        lChar = Len(strKey) + 1
                        Do While Mid(strLine, lChar, 1) = " "
                        Loop
                        If Mid(strLine, lChar, 1) = "=" Then
                            ' Matched key
                            ReadString = Right(strLine, Len(strLine) - lChar)
                            Exit Function
                        End If
                    End If
                End If
            End If
        End If
    Next

End Function

' Ecrit un string dans une section spcifie avec la cl donne
Public Sub WriteString(ByVal strSection As String, ByVal strKey As String, ByVal strValue As String)
Dim i As Long
Dim j As Long
Dim strLine As String
Dim fInSection As Boolean

    ' Ensure the key dont already exists
    ' Search section
    For i = 0 To UBound(m_strLines)
        ' Current Line
        strLine = m_strLines(i)
        If Len(strLine) > 0 Then
            If Left$(strLine, 1) <> ";" Then
                ' Compatibility with previous version
                If InStr(strLine, "'") = 1 Then
                    strLine = Right$(strLine, Len(strLine) - 1)
                End If
                
                If Left(strLine, 1) = "[" Then
                    If fInSection Then
                        ' Key not found, add at the end of the section
                        If m_strLines(UBound(m_strLines)) <> "" Then
                            ReDim Preserve m_strLines(UBound(m_strLines) * 2)
                        End If
                            
                        For j = UBound(m_strLines) - 1 To i Step -1
                            m_strLines(j + 1) = m_strLines(j)
                        Next
                        
                        m_strLines(i) = strKey + "=" + strValue
                        Exit Sub
                    ElseIf LCase(strLine) = LCase("[" + strSection + "]") Then
                        ' Matched section
                        fInSection = True
                    End If
                    
                ElseIf fInSection Then
                    If LCase(Left(strLine, Len(strKey))) = LCase(strKey) Then
                        ' Matched key, replace the line
                        m_strLines(i) = strKey + "=" + strValue
                        Exit Sub
                    End If
                End If
            End If
        End If
    Next
        
    ' Not found, add a section, search last line
    i = i - 1
    Do While i > 0
        strLine = m_strLines(i)
        If Len(strLine) > 0 Then
            i = i + 1
            Exit Do
        End If
        i = i - 1
    Loop
    
    ' Ensure the size of the array
    If i < 0 Or i > UBound(m_strLines) Then
        i = UBound(m_strLines) + 1
        If UBound(m_strLines) > 0 Then
            ReDim Preserve m_strLines(UBound(m_strLines) * 2)
        Else
            ReDim m_strLines(10)
        End If
    End If
        
    ' Section not found, add a new section
    If fInSection = False Then
        m_strLines(i) = "[" + strSection + "]"
        i = i + 1
    
        ' Ensure the size of the array
        If i > UBound(m_strLines) Then
            ReDim Preserve m_strLines(UBound(m_strLines) * 2)
        End If
    End If
    
    ' Add key
    m_strLines(i) = strKey + "=" + strValue

End Sub

' Save the current configuration into the specified file
Public Function Save(Optional ByVal strFile As String) As Boolean
Dim lhFile As Long
Dim ab() As Byte
Dim i As Long
Dim j As Long
Dim strTemp As String
Dim lLength As Long
Dim tOpenBuff As OFSTRUCT
Dim lWritten As Long
Dim lResult As Long

    ' Read the file content
    Err.Clear
    On Error GoTo ErrorFlag
    
    If Len(strFile) = 0 Then
        strFile = m_strFile
    End If
    
    ' Create a temporary file to prevent the destruction of the current file if already exists
    strTemp = GetTempFile()

    ' Create byte array
    ReDim ab(1024)
    lLength = 0
    For i = 0 To UBound(m_strLines)
        If Len(m_strLines(i)) > 0 Then
            ' Ensure size array
            Do While lLength + Len(m_strLines(i)) + 2 > UBound(ab)
                ReDim Preserve ab(UBound(ab) * 2)
            Loop
        
            For j = 1 To Len(m_strLines(i))
                ab(lLength) = Asc(Mid(m_strLines(i), j, 1))
                lLength = lLength + 1
            Next
            
            ab(lLength) = 13
            lLength = lLength + 1
            ab(lLength) = 10
            lLength = lLength + 1
        End If
    Next
    
    'Open the file
    If IsWin9x Then
        lhFile = OpenFile(strTemp, tOpenBuff, OF_CREATE)
    Else
        lhFile = CreateFile(strTemp, GENERIC_WRITE, 0, ByVal 0&, CREATE_ALWAYS, 0, 0)
    End If
    
    If lhFile <> 0 Then
        lResult = WriteFile(lhFile, ab(0), lLength, lWritten, ByVal 0&)
        If lWritten < lLength Then
            Call Err.Raise(10003, , "Fail to write file " + strTemp)
        End If
    Else
        Call Err.Raise(10002, , "Fail to open file " + strTemp)
    End If
    
ErrorFlag:

    If lhFile <> 0 Then
        ' Close file handle:
        Call CloseHandle(lhFile)
    End If

    If Err.Number <> 0 Then
        Call MsgBox(Err.Description, vbOKOnly Or vbCritical, App.Title)
        Exit Function
    End If
            
    On Error GoTo CopyFail
            
    If FileExists(strFile) Then
        If Delete(strFile, 10) = False Then
            Exit Function
        End If
    End If

    If Copy(strTemp, strFile, 10, True) Then
        Save = True
        m_strFile = strFile
    Else
        Call MsgBox("Fail to copy temporary file into destination file", vbOKOnly Or vbCritical, App.Title)
    End If
    
    On Error Resume Next
    
    Call Delete(strTemp, 1)

    Exit Function
CopyFail:
    Call MsgBox(Err.Description, vbOKOnly Or vbCritical, App.Title)
End Function

' Return if the content of this mox and the specified mox are equals
Public Function Compare(ByVal cMox As cINI) As Boolean
Dim strCurrentSection As String
Dim strKey As String
Dim strValue As String
Dim i As Long
Dim strLine As String
Dim lEqualPosition As Long

    If Me.CountActiveLines <> cMox.CountActiveLines Then
        ' Not equals
        Exit Function
    End If
    
    For i = 0 To UBound(m_strLines)
        ' Current Line
        strLine = m_strLines(i)
        If Len(strLine) > 0 Then
            If Left$(strLine, 1) <> ";" Then
                ' Compatibility with previous version
                If InStr(strLine, "'") = 1 Then
                    strLine = Right$(strLine, Len(strLine) - 1)
                End If
                
                If Left(strLine, 1) = "[" Then
                    strCurrentSection = Mid(strLine, 2, Len(strLine) - 2)
                ElseIf Len(strCurrentSection) > 0 Then
                    ' Extract key and value
                    lEqualPosition = InStr(strLine, "=")
                    If lEqualPosition > 0 Then
                        strKey = Left(strLine, lEqualPosition - 1)
                        strValue = Right(strLine, Len(strLine) - lEqualPosition)
                        
                        If (strValue <> cMox.ReadString(strCurrentSection, strKey)) Then
                            ' Not equals
                            Exit Function
                        End If
                    Else
                        ' Euhh what to do? no equals
                        Debug.Assert False
                        Exit Function
                    End If
                Else
                    ' Euhh what to do? no sections
                    Debug.Assert False
                    Exit Function
                End If
            Else
                ' Commented line
            End If
        End If
    Next
    
    ' If we arrive here, the files content are identical
    Compare = True
    
End Function

Function CountActiveLines() As Long
Dim iCount As Long
Dim i As Long

    For i = 0 To UBound(m_strLines)
        If Len(m_strLines(i)) > 0 Then
            iCount = iCount + 1
        End If
    Next
    
    CountActiveLines = iCount
End Function

Public Function GetKeysInSection(ByVal strSection As String) As String()
Dim strKeys() As String
Dim strLine As String
Dim i As Long
Dim fInSection As Boolean
Dim lKey As Long
Dim lEqualPosition As Long

    ReDim strKeys(10)
    lKey = 0
    
    ' Search section
    For i = 0 To UBound(m_strLines)
        ' Current Line
        strLine = m_strLines(i)
        If Len(strLine) > 0 Then
            If Left$(strLine, 1) <> ";" Then
                ' Compatibility with previous version
                If InStr(strLine, "'") = 1 Then
                    strLine = Right$(strLine, Len(strLine) - 1)
                End If
                
                If Left(strLine, 1) = "[" Then
                    If fInSection Then
                        ' Not found
                        GetKeysInSection = strKeys
                        Exit Function
                    ElseIf LCase(strLine) = LCase("[" + strSection + "]") Then
                        ' Matched section
                        fInSection = True
                    End If
                ElseIf fInSection Then
                    lEqualPosition = InStr(strLine, "=")
                    If lEqualPosition > 0 Then
                        ' Ensure the size of the array
                        If lKey > UBound(strKeys) Then
                            ReDim Preserve strKeys(UBound(strKeys) * 2)
                        End If
                        strKeys(lKey) = Trim$(Left$(strLine, lEqualPosition - 1))
                        lKey = lKey + 1
                    End If
                End If
            End If
        End If
    Next
    
    If lKey > 0 Then
        ReDim Preserve strKeys(lKey - 1)
    End If
    
    GetKeysInSection = strKeys

End Function

Public Function GetValuesInSection(ByVal strSection As String) As String()
Dim strValues() As String
Dim strLine As String
Dim i As Long
Dim fInSection As Boolean
Dim lValue As Long
Dim lEqualPosition As Long

    ReDim strValues(10)
    lValue = 0
    
    ' Search section
    For i = 0 To UBound(m_strLines)
        ' Current Line
        strLine = m_strLines(i)
        If Len(strLine) > 0 Then
            If Left$(strLine, 1) <> ";" Then
                ' Compatibility with previous version
                If InStr(strLine, "'") = 1 Then
                    strLine = Right$(strLine, Len(strLine) - 1)
                End If
                
                If Left(strLine, 1) = "[" Then
                    If fInSection Then
                        ' Not found
                        GetValuesInSection = strValues
                        Exit Function
                    ElseIf LCase(strLine) = LCase("[" + strSection + "]") Then
                        ' Matched section
                        fInSection = True
                    End If
                ElseIf fInSection Then
                    lEqualPosition = InStr(strLine, "=")
                    If lEqualPosition > 0 Then
                        ' Ensure the size of the array
                        If lValue > UBound(strValues) Then
                            ReDim Preserve strValues(UBound(strValues) * 2)
                        End If
                        strValues(lValue) = Trim$(Right$(strLine, Len(strLine) - lEqualPosition))
                        lValue = lValue + 1
                    End If
                End If
            End If
        End If
    Next
    
    If lValue > 0 Then
        ReDim Preserve strValues(lValue - 1)
    End If
    
    GetValuesInSection = strValues

End Function

Public Function RemoveKey(ByVal strSection As String, ByVal strKey As String)
Dim strLine As String
Dim i As Long
Dim fInSection As Boolean
Dim lChar As Long
Dim j As Long

    ' Search section
    For i = 0 To UBound(m_strLines)
        ' Current Line
        strLine = m_strLines(i)
        If Len(strLine) > 0 Then
            If Left$(strLine, 1) <> ";" Then
                ' Compatibility with previous version
                If InStr(strLine, "'") = 1 Then
                    strLine = Right$(strLine, Len(strLine) - 1)
                End If
                
                If Left(strLine, 1) = "[" Then
                    If fInSection Then
                        ' Not found
                        Exit Function
                    ElseIf LCase(strLine) = LCase("[" + strSection + "]") Then
                        ' Matched section
                        fInSection = True
                    End If
                ElseIf fInSection Then
                    If LCase(Left(strLine, Len(strKey))) = LCase(strKey) Then
                        lChar = Len(strKey) + 1
                        Do While Mid(strLine, lChar, 1) = " "
                        Loop
                        If Mid(strLine, lChar, 1) = "=" Then
                            ' Matched key
                            For j = i + 1 To UBound(m_strLines)
                                m_strLines(j - 1) = m_strLines(j)
                            Next
                            m_strLines(UBound(m_strLines)) = ""
                            Exit Function
                        End If
                    End If
                End If
            End If
        End If
    Next
End Function

Public Function RemoveSection(ByVal strSection As String)
Dim strLine As String
Dim i As Long
Dim lCurrentIndex As Long
Dim fInSection As Boolean

    ' Search section
    lCurrentIndex = -1
    For i = 0 To UBound(m_strLines)
        ' Current Line
        strLine = m_strLines(i)
        If Len(strLine) > 0 Then
            If Left$(strLine, 1) <> ";" Then
                ' Compatibility with previous version
                If InStr(strLine, "'") = 1 Then
                    strLine = Right$(strLine, Len(strLine) - 1)
                End If
                
                If Left(strLine, 1) = "[" Then
                    If LCase(strLine) = LCase("[" + strSection + "]") Then
                        ' Matched section
                        fInSection = True
                    Else
                        lCurrentIndex = lCurrentIndex + 1
                        fInSection = False
                    End If
                ElseIf fInSection Then
                    ' Skip
                Else
                    lCurrentIndex = lCurrentIndex + 1
                End If
            End If
            
            If Not fInSection Then
                If lCurrentIndex <> i Then
                    m_strLines(lCurrentIndex) = m_strLines(i)
                End If
            End If
        End If
    Next
    
    If lCurrentIndex < UBound(m_strLines) Then
        For i = lCurrentIndex + 1 To UBound(m_strLines)
            m_strLines(i) = ""
        Next
    End If
End Function

